#!/bin/sh -x

VERSION=`awk ' /^source:/ { print $2 }' version`
RELEASE=1

sdir=`pwd`
files="../sid_${VERSION}-${RELEASE}.diff.gz ../sid_${VERSION}-${RELEASE}.dsc  ../sid_${VERSION}-${RELEASE}_i386.changes ../sid_${VERSION}.orig.tar.gz"

#dch -i # required for new versions

rm -f $files
# we needn't do this really, as we've got the debian package files
# customized already. however, we like to document the whole package
# building procedure
#dh_make -e harald@deppeler.org -f ../sid-${VERSION}.tar.gz -s

#mv debian debian.org

for package in sidu sidk
do
	mv debian.$package debian
	dpkg-buildpackage -rfakeroot -tc
	mv debian debian.$package

	# test
	dpkg --contents ../${package}_${VERSION}-1_i386.deb | awk '{ print $6 }' | sort | diff - ${package}.files 
	if [ $? == 0 ]
	then
		echo "$package package complete"
	else
		echo "error: $package package incomplete!"
		echo "exiting ..."
		exit 1
	fi
done

#rm -rf debian.org
rm -f $files

exit 0

# comments for the author
# 0) if necessary, rename the current 'sid' directory to
#    sid-'version' where version is the sid version.
# 1) update version file
# 2) update changelog for debian.sid{k|u}
# 3) run ./build_debian_packages.sh
