/*
 * $Header: /cvsroot/sid/sid/kernel/sha1_kernel.h,v 1.4 2004/02/22 14:59:34 deppeler Exp $
 */

#ifndef _SHA1_KERNEL_H
#define	_SHA1_KERNEL_H

#ifndef __KERNEL__
# ifndef _SYS_TYPES_H
#  include <sys/types.h>
#endif

#ifdef Linux
#  ifndef _INTTYPES_H
#   include <inttypes.h>
#  endif
# else
#  ifndef _SYS_INTTYPES_H
#   include <sys/inttypes.h>
#  endif
# endif
#endif

/* POINTER defines a generic pointer type */
typedef unsigned char *POINTER;

/* UINT4 defines a four byte word */
typedef uint32_t UINT4;

/* BYTE defines a unsigned character */
typedef unsigned char BYTE;

typedef struct 
{
	UINT4 digest[ 5 ];            /* Message digest */
	UINT4 countLo, countHi;       /* 64-bit bit count */
	UINT4 data[ 16 ];             /* SHS data buffer */
	int Endianness;
} SHA_CTX;

/* Message digest functions */

void SHAInit(SHA_CTX *);
void SHAUpdate(SHA_CTX *, BYTE *buffer, int count);
void SHAFinal(BYTE *output, SHA_CTX *);
void SHAtoByte(BYTE *output, UINT4 *input, unsigned int len);

#ifndef _ENDIAN_H_
#define _ENDIAN_H_ 1

void endianTest(int *endianness);
void k_memset(unsigned char *s, int c, size_t n); 
void k_memcpy(unsigned char *d, unsigned char *s, size_t n); 

#endif /* end _ENDIAN_H_ */

#ifndef TRUE
  #define FALSE	0
  #define TRUE	( !FALSE )
#endif /* TRUE */

#endif	/* _SHA1_KERNEL_H */
