/*
 * $Header: /cvsroot/sid/sid/kernel/sid.h,v 1.3 2004/11/17 16:41:50 deppeler Exp $
 */

#ifndef _SYS_SID_H
#define	_SYS_SID_H

#include <sys/termios.h>
#include "sha1_kernel.h"

#include <sys/types.h>
#include <sys/param.h>
#include <sys/stream.h>
#include <sys/stropts.h>
#include <sys/termio.h>
#include <sys/pcb.h>
#include <sys/signal.h>
#include <sys/cred.h>
#include <sys/strtty.h>
#include <sys/errno.h>
#include <sys/cmn_err.h>
#include <sys/jioctl.h>
#include <sys/ptms.h>
#include <sys/debug.h>
#include <sys/kmem.h>
#include <sys/ddi.h>
#include <sys/sunddi.h>
#include <sys/cmn_err.h>


/*
 * This is the loadable module wrapper.
 */
#include <sys/conf.h>
#include <sys/modctl.h>

#ifdef	__cplusplus
extern "C" {
#endif

void cmn_err(int level, char *format, ...);
int mod_install(struct modlinkage *modlinkage);
int mod_remove(struct modlinkage *modlinkage);
int mod_info(struct modlinkage *modlinkage, struct modinfo *modinfo);
void *kmem_alloc(size_t size, int flag);
void kmem_free(void*buf, size_t size);
void qprocson(queue_t *q);
void qprocsoff(queue_t *q);
void putnext(queue_t *q, mblk_t *mp);

#define MAX_LINE_LENGTH 81
/*
 * The sid data structure used to define the global data
 * for the sid streams module
 */
struct sid {
	tcflag_t cflags;	/* copy of c_cflags */
	queue_t *q_ptr;		/* sid read queue */
	struct winsize wsz;	/* struct to hold the windowing info. */
	dev_t dev;		/* dev associated with this module */
	long lines;		/* nr of lines */
	int cp;			/* 'character counter' for the line below */
	unsigned char line[MAX_LINE_LENGTH];		/* line we want to log */
};

#ifdef SIDDEBUG
int	sid_debug = 7;
#define	DEBUG1(a)	if (sid_debug == 1) printf a
#define	DEBUG2(a)	if (sid_debug >= 2) printf a	/* allocations */
#define	DEBUG3(a)	if (sid_debug >= 3) printf a	/* M_CTL Stuff */
#define	DEBUG4(a)	if (sid_debug >= 4) printf a	/* M_READ Stuff */
#define	DEBUG5(a)	if (sid_debug >= 5) printf a
#define	DEBUG6(a)	if (sid_debug >= 6) printf a
#define	DEBUG7(a)	if (sid_debug >= 7) printf a
#else
#define	DEBUG1(a)
#define	DEBUG2(a)
#define	DEBUG3(a)
#define	DEBUG4(a)
#define	DEBUG5(a)
#define	DEBUG6(a)
#define	DEBUG7(a)
#endif		/* SIDDEBUG */

#ifdef	__cplusplus
}
#endif

#endif	/* _SYS_SID_H */
