/* $Header: /cvsroot/sid/sid/user/c_tsw.c,v 1.29 2005/01/02 22:26:30 deppeler Exp $ */

#include "c_tsw.h"
#include "sha1_kernel.h"

int debug = 0;
struct host_cfg *cur_host = NULL;	/* points to current host configuration */
struct tsw_time *cur_time = NULL;		/* used while scanning */

int main(int argc, char **argv)
{
	setprogname("tsw");

	/* get args */
	cmd_line_opts = cmd_parse(argc, argv);
	if (cmdargs_check(cmd_line_opts) > 0) {
		usage();
		exit(-1);
	}
	debug = cmd_line_opts->debug;

	/* generate a hash only? */
	if (cmd_line_opts->s == 1) {
		if (gen_pass() != 0)
			eprintf
			    (-3, "error generating hash: contact the author to fix the source. Exiting\n");
		exit(0);
	}

	if (get_config(cmd_line_opts->file, cmd_line_opts->t) < 0) {
		eprintf(-1, "fatal error: check configuration file syntax.\n");
	}
	if (activate_config() < 0) {
		eprintf(-2, "fatal error: configuration activation failed.\n");
	}

	/* fork to background */
	if (become_daemon(cmd_line_opts) < 0) {
		eprintf(-3, "error: forking to background failed.\n");
	}

	signal(SIGHUP, sid_sighup);

	if (tail_on_file(config) < 0) {
		eprintf(2, "fatal error: tail_on_file failed.\n");
	}

	free_and_exit(0);
	/* never reached */
	return 0;
}

/* indent -kr -i8 -ts8 -sob -l80 -ss -ncs */
